Subject: bug#41373: GNU ELPA: Add "reporting bugs" to individual package pages

From: Eric Abrahamsen <[email-masked]>
Date: Mon, 25 May 2020 08:39:10 -0700

Bastien <[email-masked]> writes:

> Hi Eric,
>
> Eric Abrahamsen <[email-masked]> writes:
>
>> Richard Stallman <[email-masked]> writes:
>>
>>> [[[ To any NSA and FBI agents reading my email: please consider    ]]]
>>> [[[ whether defending the US Constitution against all enemies,     ]]]
>>> [[[ foreign or domestic, requires you to follow Snowden's example. ]]]
>>>
>>> We could have report-emacs-bug ask for which package the bug is in.
>>> The Bug Subject argument could be one of the acceptable package names,
>>> including 'emacs' and whichever ELPA packages have been loaded.  The
>>> user could specify one of those.
>>>
>>> If the definition of a package says where to send bug reports for it,
>>> report-emacs-bug could send each bug to the right place.
>>>
>>> If Bug Subject argument isn't on that list, report-emacs-bug could ask,
>>> "Would you like to specify one of the ELPA packages that have been
>>> loaded?"  But you would not have to do that.  If Bug Subject is unknown,
>>> the message would go to bug-gnu-emacs, as now.
>>
>> Several years ago I cooked up something basic like that. I've attached
>> the patch from that thread, which might serve as the basis for something
>> usable.
>
> I tested your patch and it looks really useful to me.
>
> Two things that come to my mind:
>
> - Package completion could not find "org" as a package: still, a bare
>   emacs -q list Org as a built-in package.  Maybe we can add those to
>   the completion list?

I think in the original discussion the patch went back and forth between
completing on `package-alist' and completing on `features'. The former
didn't offer enough, the latter offered too much.

> - If completion fails, then the bug reporting process is stopped,
>   which may be confusing for users -- when there is no completion,
>   I suggest to fall back on the current report-emacs-bug behavior.

Yes, that's a bug! It shouldn't require a package.

> - I wonder what happens if the "maintainer" email is a mailing list
>   address: this might lead to confusion, with people cross-posting to
>   both [email-masked] and [email-masked] for example,
>   which would perhaps lead to some more confusion because bugs on
>   [email-masked] are posted to [email-masked] when they
>   are tagged "org-mode" (if I understand correctly).

If we complete on `features', that's definitely an issue. I think my
solution in that version of the patch simply dropped the issue if the
Maintainer header was emacs-devel, or there was no Maintainer.

> A simple solution for the last issue would be to forbid mailing list
> addresses in the "maintainer" email field.  In the case of org-mode,
> for example, the address could be that of someone in charge of doing
> bug triage, assigning tags to [email-masked] when needed.
>
> In any case, thanks for spending time on this!

My pleasure -- as Dmitry notes, this might not solve the problem that
this thread is about, but I think it's definitely worthwhile on its own.

Eric